package cpcns.ldanganzhengli.ldanganhe.controller;

package .tmp;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.common.controller.commonController;
import cpcns.ldanganzhengli.ldanganhe.model.LDDangAnHe;
import cpcns.ldanganzhengli.ldanganhe.service.ILDDangAnHeService;
import cpcns.utils.CommStatic;
import cpcns.utils.DateUtil;
import cpcns.utils.Json;
import cpcns.utils.PagerVO;
import java.io.IOException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import net.sf.json.JSONObject;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping({"/LDDangAnHe"})
public class LDDangAnHeController extends commonController {
  @Autowired
  private ILDDangAnHeService LDDangAnHeService;
  
  @RequestMapping({"/query.do"})
  public String execute(HttpServletRequest request) throws Exception {
    String guiDangNianDubegin = request.getParameter("guiDangNianDubegin");
    String guiDangNianDuend = request.getParameter("guiDangNianDuend");
    String piCiHao = request.getParameter("piCiHao");
    String leiXing = request.getParameter("leiXing");
    String menLei = request.getParameter("menLei");
    String hangBiaoShis = request.getParameter("hangBiaoShis");
    getRequest().setAttribute("hangBiaoShis", hangBiaoShis);
    getRequest().setAttribute("menLei", menLei);
    getRequest().setAttribute("leiXing", leiXing);
    getRequest().setAttribute("piCiHao", piCiHao);
    getRequest().setAttribute("guiDangNianDuend", guiDangNianDuend);
    getRequest().setAttribute("guiDangNianDubegin", guiDangNianDubegin);
    return "ldanganzhengli/ldanganhe/LDDangAnHeList";
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, HttpServletResponse response) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    if (hangBiaoShi != null && !hangBiaoShi.equals("")) {
      LDDangAnHe cla = (LDDangAnHe)this.LDDangAnHeService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      String sb = " select min(xuHao) from " + CommStatic.getMenLeiToBiaoMing(cla.getMenLei()) + " where guanLianBiaoShi= " + cla.getHangBiaoShi();
      List<String> list = this.LDDangAnHeService.selectSql(sb);
      if (list != null && list.size() > 0 && list.get(0) != null && list.get(0) != "")
        cla.setQiYeHao(Integer.valueOf(list.get(0).toString())); 
      sb = " select max(xuHao) from " + CommStatic.getMenLeiToBiaoMing(cla.getMenLei()) + " where guanLianBiaoShi= " + cla.getHangBiaoShi();
      list = this.LDDangAnHeService.selectSql(sb);
      if (list != null && list.size() > 0 && list.get(0) != null && list.get(0) != "")
        cla.setZhiYeHao(Integer.valueOf(list.get(0).toString())); 
      cla.setChrq(DateUtil.getDate(cla.getChengHeShiJian()));
      getRequest().setAttribute("dangAnHe", cla);
    } 
    return "ldanganzhengli/ldanganhe/LDDangAnHeEdit";
  }
  
  @RequestMapping({"/toHeNeiJian.do"})
  public String toHeNeiJian() {
    String hangBiaoShi = getRequest().getParameter("hangBiaoShi");
    String menLei = getRequest().getParameter("menLei");
    getRequest().setAttribute("table", CommStatic.getMenLeiToBiaoMing(menLei));
    getRequest().setAttribute("menLei", menLei);
    getRequest().setAttribute("heBiaoShi", hangBiaoShi);
    return "ldanganzhengli/ldanganhe/LDHeNeiJian";
  }
  
  @RequestMapping({"/getAll.do"})
  public void getAll(HttpServletRequest request, HttpServletResponse response) throws IOException {
    Enumeration<?> rnames = getRequest().getParameterNames();
    JSONObject jsonObject = new JSONObject();
    for (Enumeration<?> er = rnames; er.hasMoreElements(); ) {
      String thisName = er.nextElement().toString();
      String thisValue = getRequest().getParameter(thisName);
      jsonObject.put(thisName, thisValue);
    } 
    User user = getCurrentUser();
    StringBuffer sqlWhere = new StringBuffer();
    Iterator<String> iterator = jsonObject.keys();
    StringBuffer sqlSearch = new StringBuffer();
    sqlSearch.append(" 1=1 ");
    String hbs_n1 = isJianDing(request);
    if (StringUtils.isNotBlank(hbs_n1))
      sqlSearch.append(" and hangBiaoShi not in (" + hbs_n1 + ")"); 
    while (iterator.hasNext()) {
      String key = iterator.next();
      String value = jsonObject.getString(key);
      if (value != null && !value.trim().equals("") && !key.equals("page") && !key.equals("rows") && !"order".equals(key) && !"sort".equals(key) && !"type".equals(key)) {
        if (key.contains("begin")) {
          key = key.substring(0, key.indexOf("begin"));
          if ("guiDangNianDu".equals(key)) {
            sqlWhere.append(" and ").append(String.valueOf(key) + " >= '" + value + "'");
            continue;
          } 
          sqlWhere.append(" and ").append(String.valueOf(key) + " >= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (key.contains("end")) {
          key = key.substring(0, key.indexOf("end"));
          if ("guiDangNianDu".equals(key)) {
            sqlWhere.append(" and ").append(String.valueOf(key) + " <= '" + value + "'");
            sqlWhere.append(" and zhuangTai=1");
            continue;
          } 
          sqlWhere.append(" and ").append(String.valueOf(key) + " <= " + "to_date('" + value + "','yyyy-mm-dd')");
          continue;
        } 
        if (!"server".equals(key) && !"table".equals(key)) {
          if (key.contains("like")) {
            key = key.substring(0, key.indexOf("like"));
            sqlWhere.append(" and ").append(String.valueOf(key) + " like " + "'%" + value + "%'");
            continue;
          } 
          if ("yiJiaoPiCi".equals(key)) {
            sqlWhere.append(" and zhuangTai=5");
            continue;
          } 
          if (key.equals("hangBiaoShis")) {
            sqlWhere.append(" and ").append(" hangBiaoShi in ( " + value + ")");
            continue;
          } 
          sqlWhere.append(" and ").append(String.valueOf(key) + " = '" + value + "'");
        } 
      } 
    } 
    if (sqlWhere.length() > 0)
      sqlSearch.append(sqlWhere.toString()); 
    sqlSearch.append(" and baoGuanQiXian !='D10'");
    String type = (request.getParameter("type") == null) ? "D" : request.getParameter("type");
    String ml = (request.getParameter("menLei") == null) ? request.getParameter("menLeilike") : request.getParameter("menLei");
    String tb = CommStatic.getMenLeiToBiaoMing(ml).replaceAll("D_", String.valueOf(type) + "_");
    sqlSearch.append(" and hangBiaoShi not in (select distinct wj.guanLianBiaoShi from " + tb + " wj where wj.guanLianBiaoShi=hangBiaoShi and wj.jieYueZhuangTai=1 and wj.guiDangLeiXing=2)");
    String page = request.getParameter("page");
    String rows = request.getParameter("rows");
    int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
    int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
    int start = (intPage - 1) * number;
    String tb_ = "D_DangAnHe".replace("D_", String.valueOf(type) + "_");
    StringBuffer sql = new StringBuffer("select hangBiaoShi,xuHao,quanZongHao,fenShu,heRongLiang,zhuangTai,zeRenRenMingCheng,guiDangBuMenMingCheng,baoGuanQiXian,guiDangNianDu,menLei,fenLeiMingCheng,miJi,ruKuFangZhuangTai,yiJiaoPiCi from " + tb_ + " where ");
    PagerVO pagevo = this.LDDangAnHeService.getAll(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "hangBiaoShi"), tb_);
    String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
    jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("XUHAO", "xuHao")
      .replaceAll("FENSHU", "fenShu").replaceAll("HERONGLIANG", "heRongLiang").replaceAll("QUANZONGHAO", "quanZongHao")
      .replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("ZERENRENMINGCHENG", "zeRenRenMingCheng")
      .replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian")
      .replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("MENLEI", "menLei").replaceAll("FENLEIMINGCHENG", "fenLeiMingCheng")
      .replaceAll("MIJI", "miJi").replaceAll("RUKUFANGZHUANGTAI", "ruKuFangZhuangTai").replaceAll("YIJIAOPICI", "yiJiaoPiCi");
    write(response, jsonString);
  }
  
  @RequestMapping({"/getAllbyPiCiHao.do"})
  public void getAllByPiCiHao(HttpServletRequest request, HttpServletResponse response) throws IOException {
    String yiJiaoPiCi = request.getParameter("yiJiaoPiCi");
    if (StringUtils.isNotBlank(yiJiaoPiCi)) {
      StringBuffer sqlSearch = new StringBuffer();
      sqlSearch.append(" 1=1 ");
      sqlSearch.append("and yiJiaoPiCi ='" + yiJiaoPiCi + "'");
      String page = request.getParameter("page");
      String rows = request.getParameter("rows");
      int intPage = Integer.parseInt((page == null || page == "0") ? "0" : page);
      int number = Integer.parseInt((rows == null || rows == "0") ? "0" : rows);
      int start = (intPage - 1) * number;
      StringBuffer sql = new StringBuffer("select hangBiaoShi,xuHao,quanZongHao,fenShu,guiDangBuMenMingCheng,zhuangTai,baoGuanQiXian,guiDangNianDu,menLei,yiJiaoPiCi from D_DangAnHe where ");
      PagerVO pagevo = this.LDDangAnHeService.getAll(start, number, sql.toString(), sqlSearch.toString(), CommStatic.getOrderBy(request, "hangBiaoShi"));
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo);
      jsonString = jsonString.replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("XUHAO", "xuHao").replaceAll("FENSHU", "fenShu").replaceAll("QUANZONGHAO", "quanZongHao").replaceAll("ZHUANGTAI", "zhuangTai").replaceAll("GUIDANGBUMENMINGCHENG", "guiDangBuMenMingCheng").replaceAll("BAOGUANQIXIAN", "baoGuanQiXian").replaceAll("GUIDANGNIANDU", "guiDangNianDu").replaceAll("MENLEI", "menLei").replaceAll("MIJI", "miJi").replaceAll("YIJIAOPICI", "yiJiaoPiCi");
      write(response, jsonString);
    } 
  }
  
  private String isJianDing(HttpServletRequest request) {
    String menLei = request.getParameter("menLei");
    StringBuffer sql_qx = new StringBuffer("select qx.jianDingBiaoShi from D_BaoGuanQiXianJianDing qx,D_JianDingFangAn fa where qx.guanLianBiaoShi=fa.hangBiaoShi and fa.jianDingZhuangTai=1");
    StringBuffer sql_gk = new StringBuffer("select gk.jianDingBiaoShi from D_WenJianMiJiJianDing gk,D_JianDingFangAn fa where gk.guanLianBiaoShi=fa.hangBiaoShi and fa.jianDingZhuangTai=1");
    StringBuffer retu = new StringBuffer();
    List<String> qx = this.LDDangAnHeService.getList(sql_qx.toString());
    if (qx != null && qx.size() > 0)
      for (int i = 0; i < qx.size(); i++) {
        if (StringUtils.isBlank(retu.toString())) {
          retu.append(qx.get(i));
        } else {
          retu.append("," + qx.get(i));
        } 
      }  
    List<String> gk = this.LDDangAnHeService.getList(sql_gk.toString());
    if (gk != null && gk.size() > 0)
      for (int i = 0; i < gk.size(); i++) {
        if (StringUtils.isBlank(retu.toString())) {
          retu.append(gk.get(i));
        } else {
          retu.append("," + gk.get(i));
        } 
      }  
    String ret = getJH(retu.toString());
    return ret;
  }
  
  private String isOrNotJieYue() {
    StringBuffer hangBiaoShi = new StringBuffer();
    String da = (new SimpleDateFormat("yyyy-MM-dd")).format(new Date());
    StringBuffer sql = new StringBuffer("select wj.guanLianBiaoShi from D_LiYongWenJian wj,D_LiYongShenQingDan sqd where wj.shenQingDanBiaoShi=sqd.hangBiaoShi and sqd.liYongFangShi=20 and wj.zhuangTai=1");
    List<String> lis = this.LDDangAnHeService.getList(sql.toString());
    if (lis != null && lis.size() > 0)
      for (int i = 0; i < lis.size(); i++) {
        if (StringUtils.isBlank(hangBiaoShi.toString())) {
          hangBiaoShi.append(lis.get(i));
        } else {
          hangBiaoShi.append("," + lis.get(i));
        } 
      }  
    String ret = getJH(hangBiaoShi.toString());
    return ret;
  }
  
  private String getJH(String hangBiaoShi) {
    StringBuffer ret = new StringBuffer();
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      StringBuffer sql_h = new StringBuffer("select distinct guanLianBiaoShi from D_WenJian where hangBiaoShi in (" + hangBiaoShi + ")");
      List<String> jh = this.LDDangAnHeService.getList(sql_h.toString());
      if (jh != null && jh.size() > 0)
        for (int i = 0; i < jh.size(); i++) {
          if (StringUtils.isBlank(ret.toString())) {
            ret.append(jh.get(i));
          } else {
            ret.append("," + jh.get(i));
          } 
        }  
    } 
    return ret.toString();
  }
  
  @RequestMapping({"/openDat.do"})
  @ResponseBody
  public String returnJos(HttpServletRequest request, HttpServletResponse response, Model model) {
    String hangBiaoShi = request.getParameter("hangBiaoShi");
    Map<String, Object> resultMap = new HashMap<>();
    resultMap.put("filePath", "");
    String jsonString = "";
    if (StringUtils.isNotBlank(hangBiaoShi)) {
      LDDangAnHe cla = (LDDangAnHe)this.LDDangAnHeService.getById(Integer.valueOf(Integer.parseInt(hangBiaoShi)));
      resultMap.put("filePath", cla);
    } 
    jsonString = Json.Map2Json(resultMap);
    return jsonString;
  }
}
